/* 
 * File:   RoiAction.h
 * Author: Marcel Duris
 *
 * Created on March 24, 2012, 2:04 PM
 * 
 * Trieda akcie umoznujuca vybrat region zaujmu.
 */

#include "SelectAction.h"
#include <cstdlib>
#include <cstdio>
#include <opencv2/core/core.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <opencv2/highgui/highgui.hpp>

#ifndef ROIACTION_H
#define	ROIACTION_H

class RoiAction : public SelectAction {
public:
    RoiAction(Mat img);
    RoiAction(const RoiAction& orig);
    virtual ~RoiAction();
    virtual void processMouseInput(int event, int x, int y, int flags);
    virtual void processKeyboardInput(int key);
    virtual bool finished();
    virtual Mat getImg();
    virtual Mat getMask();
    
    Rect getRoi();
    
    static const int STATE_FINISHED = 2;
private:
    void help();

};

#endif	/* ROIACTION_H */

